# Copyright (c) 2002 Infrae. All rights reserved.
# See also LICENSE.txt
# $Revision: 1.3.2.1 $

from Interface import Base

class INewsFilter(Base):
    """NewsFilter object, a small object that shows a couple
    of different screens to different users, a filter for all NewsItem-objects
    to the editor and a filter (containing some different info) for all
    published NewsItem-objects for the end-users.
    """
    def keep_to_path(self):
        """Returns true if the item should keep to path
        """

    def number_to_show(self):
        """Returns true if the item should keep to path
        """

    def subjects(self):
        """Returns the list of subjects
        """

    def target_audiences(self):
        """Returns the list of target audiences
        """

    def set_keep_to_path(self, value):
        """Removes the filter from the list of filters where the item
        should appear
        """

    def set_subject(self, subject, on_or_off):
        """Updates the list of subjects
        """

    def set_target_audience(self, target_audience, on_or_off):
        """Updates the list of target_audiences
        """

    def set_number_to_show(self, number):
        """Updates the list of target_audiences
        """

    def get_all_items(self, meta_types):
        """Returns all items, only to be used on the back-end
        """

    def get_last_items(self, number, number_is_days, meta_types):
	"""Returns the last number of items, can be in days as well"""

    def get_next_items(self, number_of_days, meta_types):
	"""Gets the next items, should return only agenditems"""

    def get_items_by_date(self, month, year, meta_types):
	"""Returns the items for a specific month (for the archive)"""

    def get_agenda_items_by_date(self, month, year, meta_types):
	"""Returns all agendaitems for a specific month, will be used only by AgendaViewers"""
	
    def get_allowed_meta_types(self):
        """Returns all allowed meta_types
        """

    def show_agenda_items(self):
	"""Returns true if the filter passes on agendaitems"""

    def set_show_agenda_items(self, value):
	"""Sets whether the Filter should pass on agendaitems"""

    def rss_feed(self):
	"""Returns the RSS feed, should be available TTW"""

    def allow_rss_export(self):
	"""Returns whether RSS export is allowed"""

    def set_allow_rss_export(self, value):
	"""Sets whether RSS export is allowed"""

    def allow_rss_search(self):
	"""Returns whether the filter should send along info for the other side to search the channel"""

    def set_allow_rss_search(self, value):
	"""Sets whether the filter shouls send along info for the other side to search the RSS channel"""

    def set_rss_description(self, value):
	"""Sets the RSS description"""

    def set_rss_search_description(self, value):
	"""Sets the description for the search form"""

    def set_rss_link(self, value):
	"""Sets the link for the RSS feed"""

    def set_rss_copyright(self, value):
	"""Sets the RSS copyright notice"""

    def set_rss_image(self, value):
	"""Sets the RSS image"""

